## xmms2 0.7DrNo+dfsg

=== wscript ===
# encoding: utf-8
#
# WAF build scripts for XMMS2
# Copyright (C) 2006-2009 XMMS2 Team
#

import sys
if sys.version_info < (2,4):
    raise RuntimeError("Python 2.4 or newer is required")

import os
import optparse

# Waf removes the current dir from the python path. We readd it to
# import waftools stuff.
sys.path.insert(0,os.getcwd())

from waftools import gittools

import Options
import Utils
import Build
import Configure
from logging import fatal, warning

BASEVERSION="0.7 DrNo"
APPNAME='xmms2'

srcdir='.'
blddir = '_build_'

####
## Initialization
####
def init():
    import gc
    gc.disable()

subdirs = """
          src/lib/xmmstypes
          src/lib/xmmssocket
          src/lib/xmmsipc
          src/lib/xmmsutils
          src/lib/xmmsvisualization
          src/clients/lib/xmmsclient
          src/clients/lib/xmmsclient-glib
          src/include
          src/includepriv
          """.split()

optional_subdirs = ["src/clients/cli",
                    "src/clients/nycli",
                    "src/clients/launcher",
                    "src/clients/et",
                    "src/clients/mdns/dns_sd",
                    "src/clients/mdns/avahi",
                    "src/clients/medialib-updater",
                    "src/clients/vistest",
                    "src/clients/lib/xmmsclient-ecore",
                    "src/clients/lib/xmmsclient++",
                    "src/clients/lib/xmmsclient++-glib",
                    "src/clients/lib/xmmsclient-cf",
                    "src/clients/lib/python",
                    "src/clients/lib/perl",
                    "src/clients/lib/ruby",
                    "tests",
                    "pixmaps"]

def is_plugin(x):
    return os.path.exists(os.path.join("src/plugins", x, "wscript"))

all_optionals = set(os.path.basename(o) for o in optional_subdirs)
all_plugins = set(p for p in os.listdir("src/plugins") if is_plugin(p))

####
## Build
####
def build(bld):
    if bld.env["BUILD_XMMS2D"]:
        subdirs.append("src/xmms")

    newest = max([os.stat(os.path.join(sd, "wscript")).st_mtime for sd in subdirs])
    if bld.env['NEWEST_WSCRIPT_SUBDIR'] and newest > bld.env['NEWEST_WSCRIPT_SUBDIR']:
        fatal("You need to run waf configure")
        raise SystemExit

    # Process subfolders
    bld.add_subdirs(subdirs)

    # Build configured plugins
    plugins = bld.env['XMMS_PLUGINS_ENABLED']
    bld.add_subdirs(["src/plugins/%s" % plugin for plugin in plugins])

    # Build the clients
    bld.add_subdirs(bld.env['XMMS_OPTIONAL_BUILD'])

    for name, lib in bld.env['XMMS_PKGCONF_FILES']:
        obj = bld.new_task_gen('subst')
        obj.source = 'xmms2.pc.in'
        obj.target = name + '.pc'
        obj.dict = {
               'NAME': name,
                'LIB': lib,
             'PREFIX': bld.env['PREFIX'],
             'BINDIR': bld.env['BINDIR'],
             'LIBDIR': bld.env['LIBDIR'],
         'INCLUDEDIR': os.path.join(bld.env.INCLUDEDIR, "xmms2"),
            'VERSION': bld.env["VERSION"],
        }
        obj.install_path = '${PKGCONFIGDIR}'

    bld.install_files('${SHAREDDIR}', 'silence-cellule_snippet.ogg')


####
## Configuration
####
def _configure_optionals(conf):
    """Process the optional xmms2 subprojects"""
    def _check_exist(optionals, msg):
        unknown_optionals = optionals.difference(all_optionals)
        if unknown_optionals:
            fatal(msg % {'unknown_optionals': ', '.join(unknown_optionals)})
            raise SystemExit(1)
        return optionals

    conf.env['XMMS_OPTIONAL_BUILD'] = []

    if Options.options.enable_optionals != None:
        selected_optionals = _check_exist(set(Options.options.enable_optionals),
                                           "The following optional(s) were requested, "
                                           "but don't exist: %(unknown_optionals)s")
        optionals_must_work = True
    elif Options.options.disable_optionals != None:
        disabled_optionals = _check_exist(set(Options.options.disable_optionals),
                                          "The following optional(s) were disabled, "
                                          "but don't exist: %(unknown_optionals)s")
        selected_optionals = all_optionals.difference(disabled_optionals)
        optionals_must_work = False
    else:
        selected_optionals = all_optionals
        optionals_must_work = False

    failed_optionals = set()
    succeeded_optionals = set()

    for o in selected_optionals:
        x = [x for x in optional_subdirs if os.path.basename(x) == o][0]
        try:
            conf.sub_config(x)
            conf.env.append_value('XMMS_OPTIONAL_BUILD', x)
            succeeded_optionals.add(o)
        except Configure.ConfigurationError:
            failed_optionals.add(o)

    if optionals_must_work and failed_optionals:
        fatal("The following required optional(s) failed to configure: "
              "%s" % ', '.join(failed_optionals))
        raise SystemExit(1)

    disabled_optionals = set(all_optionals)
    disabled_optionals.difference_update(succeeded_optionals)

    return succeeded_optionals, disabled_optionals

def _configure_plugins(conf):
    """Process all xmms2d plugins"""
    def _check_exist(plugins, msg):
        unknown_plugins = plugins.difference(all_plugins)
        if unknown_plugins:
            fatal(msg % {'unknown_plugins': ', '.join(unknown_plugins)})
            raise SystemExit(1)
        return plugins

    conf.env['XMMS_PLUGINS_ENABLED'] = []

    # If an explicit list was provided, only try to process that
    if Options.options.enable_plugins != None:
        selected_plugins = _check_exist(set(Options.options.enable_plugins),
                                        "The following plugin(s) were requested, "
                                        "but don't exist: %(unknown_plugins)s")
        disabled_plugins = all_plugins.difference(selected_plugins)
        plugins_must_work = True
    # If a disable list was provided, we try all plugins except for those.
    elif Options.options.disable_plugins != None:
        disabled_plugins = _check_exist(set(Options.options.disable_plugins),
                                        "The following plugins(s) were disabled, "
                                        "but don't exist: %(unknown_plugins)s")
        selected_plugins = all_plugins.difference(disabled_plugins)
        plugins_must_work = False
    # If we don't have the daemon we don't build plugins.
    elif Options.options.without_xmms2d:
        disabled_plugins = all_plugins
        selected_plugins = set()
        plugins_must_work = False
    # Else, we try all plugins.
    else:
        selected_plugins = all_plugins
        disabled_plugins = set()
        plugins_must_work = False


    for plugin in selected_plugins:
        conf.sub_config("src/plugins/%s" % plugin)
        if (not conf.env["XMMS_PLUGINS_ENABLED"] or
            (len(conf.env["XMMS_PLUGINS_ENABLED"]) > 0 and
            conf.env['XMMS_PLUGINS_ENABLED'][-1] != plugin)):
            disabled_plugins.add(plugin)

    # If something failed and we don't tolerate failure...
    if plugins_must_work:
        broken_plugins = selected_plugins.intersection(disabled_plugins)
        if broken_plugins:
            fatal("The following required plugin(s) failed to configure: "
                  "%s" % ', '.join(broken_plugins))
            raise SystemExit(1)

    return conf.env['XMMS_PLUGINS_ENABLED'], disabled_plugins

def _output_summary(enabled_plugins, disabled_plugins,
                    enabled_optionals, disabled_optionals,
                    output_plugins):
    Utils.pprint('Normal', "\nOptional configuration:\n======================")
    Utils.pprint('Normal', "Enabled: ", sep='')
    Utils.pprint('BLUE', ', '.join(sorted(enabled_optionals)))
    Utils.pprint('Normal', "Disabled: ", sep='')
    Utils.pprint('BLUE', ", ".join(sorted(disabled_optionals)))
    Utils.pprint('Normal', "\nPlugins configuration:\n======================")

    enabled_plugins = [x for x in enabled_plugins if x not in output_plugins]

    Utils.pprint('Normal', "Output:")
    Utils.pprint('BLUE', ", ".join(sorted(output_plugins)))
    Utils.pprint('Normal', "XForm/Other:")
    Utils.pprint('BLUE', ", ".join(sorted(enabled_plugins)))
    Utils.pprint('Normal', "Disabled:")
    Utils.pprint('BLUE', ", ".join(sorted(disabled_plugins)))

def configure(conf):
    if os.environ.has_key('PKG_CONFIG_PREFIX'):
        prefix = os.environ['PKG_CONFIG_PREFIX']
        if not os.path.isabs(prefix):
            prefix = os.path.abspath(prefix)
        conf.env['PKG_CONFIG_DEFINES'] = {'prefix':prefix}

    conf.env["BUILD_XMMS2D"] = False
    if not Options.options.without_xmms2d == True:
        conf.env["BUILD_XMMS2D"] = True
        subdirs.insert(0, "src/xmms")

    conf.check_tool('gnu_dirs')
    conf.check_tool('man', tooldir=os.path.abspath('waftools'))
    conf.check_tool('misc')
    conf.check_tool('gcc')
    conf.check_tool('g++')

    try:
        conf.check_tool('winres')
        conf.env['WINRCFLAGS'] = '-I' + os.path.abspath('pixmaps')
        conf.env['xmms_icon'] = True
    except Configure.ConfigurationError:
        conf.env['xmms_icon'] = False

    if Options.options.target_platform:
        Options.platform = Options.options.target_platform

    nam,changed = gittools.get_info()
    conf.check_message("git commit id", "", True, nam)
    if Options.options.customversion:
        conf.env["VERSION"] = BASEVERSION + " (%s + %s)" % (nam, Options.options.customversion)
    else:
        dirty=""
        if changed:
            dirty="-dirty"
        conf.check_message("uncommitted changes", "", bool(changed))
        conf.env["VERSION"] = BASEVERSION + " (git commit: %s%s)" % (nam, dirty)

    conf.env["CCFLAGS"] = Utils.to_list(conf.env["CCFLAGS"]) + ['-g', '-O0']
    for warning in ('all',
                    'no-format-extra-args',
                    'no-format-zero-length',
                    'format-nonliteral',
                    'format-security',
                    'format=2',
                    "missing-prototypes",
                    "strict-prototypes",
                    "empty-body",
                    "ignored-qualifiers",
                    "type-limits",
                    "write-strings",
                    ):
        warnflag = "-W%s" % warning
        if conf.check_cc(cflags=warnflag):
            conf.env["CCFLAGS"].append(warnflag)
            # autogenerate uselib definitions to disable warnings
            conf.env["CCFLAGS_NO%s" % warning.replace("-","").upper()] = ["-Wno-%s" % warning]

    conf.env["CXXFLAGS"] = Utils.to_list(conf.env["CXXFLAGS"]) + ['-g', '-O0']
    conf.env['XMMS_PKGCONF_FILES'] = []
    conf.env['XMMS_OUTPUT_PLUGINS'] = [(-1, "NONE")]

    if Options.options.pkgconfigdir:
        conf.env['PKGCONFIGDIR'] = Options.options.pkgconfigdir
        print(conf.env['PKGCONFIGDIR'])
    else:
        conf.env['PKGCONFIGDIR'] = os.path.join(conf.env["LIBDIR"], "pkgconfig")

    if Options.options.config_prefix:
        for dir in Options.options.config_prefix:
            if not os.path.isabs(dir):
                dir = os.path.abspath(dir)
            conf.env.prepend_value("LIBPATH", os.path.join(dir, "lib"))
            conf.env.prepend_value("CPPPATH", os.path.join(dir, "include"))

    # Our static libraries may link to dynamic libraries
    if Options.platform != 'win32':
        conf.env["staticlib_CCFLAGS"] += ['-fPIC', '-DPIC']
    else:
        # As we have to change target platform after the tools
        # have been loaded there are a few variables that needs
        # to be initiated if building for win32.

        # Make sure we don't have -fPIC and/or -DPIC in our CCFLAGS
        conf.env["shlib_CCFLAGS"] = []

        # Setup various prefixes
        conf.env["shlib_PATTERN"] = 'lib%s.dll'
        conf.env['program_PATTERN'] = '%s.exe'

    # Add some specific OSX things

=== pixmaps/wscript ===
import os
import Options

def build(bld):
    if bld.env['xmms_icon']:
        obj = bld.new_task_gen('cc', 'objects')
        obj.target = 'xmms_icon'
        obj.source = 'xmms2.rc'
        obj.install_path = 0

    images = """
        xmms2-16.png
        xmms2-32.png
        xmms2-48.png
        xmms2-128.png
        xmms2.svg
        xmms2-black-on-white.svg
        xmms2-white-on-black.svg
    """.split()

    for image in images:
        bld.install_files("${PIXMAP_DIR}", image)

def configure(conf):
    if Options.options.pixmapdir is not None:
        conf.env.PIXMAP_DIR = Options.options.pixmapdir
    else:
        conf.env.PIXMAP_DIR = os.path.join(conf.env.DATAROOTDIR, "pixmaps")

    if not conf.env["PIXMAP_DIR"]:
        conf.fatal("No pixmap dir")

def set_options(opt):
    opt.add_option("--with-pixmap-dir", type="string", dest="pixmapdir",
                   help="Specify directory where to install pixmaps")

=== tests/wscript ===

types_suite=["xmmsv/t_xmmsv.c", "xmmsv/t_coll.c"]
server_suite=["server/t_streamtype.c"]

def configure(conf):
    conf.check_cc(header_name="CUnit/CUnit.h", mandatory=True)
    conf.check_cc(lib="cunit", uselib_store="cunit", mandatory=True)

    code = """
           static void T (void) __attribute__ ((constructor (220)));
           static void T (void) {};
    """
    conf.check_cc(fragment=code, type="cc", msg="Checking for constructor attribute", mandatory=True)

    conf.check_cfg(package='valgrind', uselib_store='valgrind', args='--cflags')

def build(bld):
    obj = bld.new_task_gen('cc', 'program')
    obj.target = "test_xmmstypes"
    obj.source = ['runner/main.c', 'runner/valgrind.c'] + types_suite
    obj.includes = '. ../ runner/ ../src ../src/include'
    obj.uselib_local = 'xmmstypes'
    obj.uselib = 'cunit valgrind'
    obj.install_path = None

    obj = bld.new_task_gen('cc', 'program')
    obj.target = "test_server"
    obj.source = ['runner/main.c', 'runner/valgrind.c', '../src/xmms/streamtype.c', '../src/xmms/object.c'] + server_suite
    obj.includes = '. ../ runner/ ../src ../src/includepriv ../src/include'
    obj.uselib_local = 'xmmstypes'
    obj.uselib = 'cunit valgrind glib2 gthread2'
    obj.install_path = None



def set_options(o):
    pass

=== src/include/wscript ===
import os

def build(bld):
    paths = ['xmms', 'xmmsc', 'xmmsclient', 'xmmsclient/xmmsclient++']
    for p in paths:
        bld.add_subdirs(p)
        f = [os.path.join(p, a) for a in os.listdir(os.path.join('src','include',p)) if a.endswith('.h')]
        bld.install_files(os.path.join(bld.env.INCLUDEDIR, 'xmms2', p), " ".join(f))

def configure(conf):
    conf.sub_config("xmms")

    return True

def set_options(env):
    pass

=== src/includepriv/wscript ===
def configure(conf):
    return True
def set_options(conf):
    pass
def build(bld):
    bld.add_subdirs("xmmspriv")
    bld.add_subdirs("xmmsclientpriv")

=== src/xmms/wscript ===
# encoding: utf-8
#
# WAF build scripts for XMMS2
# Copyright (C) 2006-2009 XMMS2 Team
#

import os
import Options
from logging import warning

source = """
    config.c
    mediainfo.c
    sqlite.c
    medialib.c
    object.c
    error.c
    output.c
    playlist.c
    collection.c
    collquery.c
    collserial.c
    collsync.c
    ipc.c
    log.c
    plugin.c
    magic.c
    ringbuf.c
    xform.c
    streamtype.c
    converter_plugin.c
    segment_plugin.c
    ringbuf_xform.c
    outputplugin.c
    bindata.c
    sample.genpy
    utils.c
    visualization/format.c
    visualization/object.c
    visualization/udp.c
    visualization/xform.c
""".split()

def build(bld):
    env = bld.env

    prog = bld.new_task_gen('cc', 'program')
    prog.target = 'xmms2d'
    prog.includes = '. ../.. ../include ../includepriv'
    prog.source = ["main.c"]
    prog.source.append("compat/signal_%s.c" % env['compat_impl'])
    prog.source.append("compat/symlink_%s.c" % env['compat_impl'])
    prog.source.append("compat/checkroot_%s.c" % env['compat_impl'])

    source.append("compat/localtime_%s.c" % env["localtime_impl"])
    source.append("compat/statfs_%s.c" % env["statfs_impl"])
    if bld.env['HAVE_SEMCTL']:
        source.append("visualization/unixshm.c")
    else:
        source.append("visualization/dummy.c")

    if env['xmms_shared_library']:
        lib = bld.new_task_gen('cc', 'shlib')
        lib.target = 'xmms2core'
        lib.source = source
        lib.includes = '. ../.. ../include ../includepriv'
        lib.uselib = 'glib2 gmodule2 gthread2 sqlite3 statfs socket shm'
        lib.uselib_local = 'xmmsipc xmmssocket xmmsutils xmmstypes xmmsvisualization'

        prog.uselib_local = 'xmms2core'
    else:
        prog.source += source
        prog.uselib_local = ''

    prog.uselib_local += ' xmmsipc xmmssocket xmmsutils xmmstypes xmmsvisualization'
    prog.uselib = 'math glib2 gmodule2 gthread2 sqlite3 statfs socket shm valgrind'

    if env['xmms_icon']:
        prog.add_objects = 'xmms_icon'

    bld.new_task_gen(features='man', files='xmms2d.1', section='1')

def configure(conf):
    conf.check_tool('python-generator', tooldir=os.path.abspath('waftools'))
    conf.check_cfg(package='gmodule-2.0', atleast_version='2.6.0', uselib_store='gmodule2', args='--cflags --libs')
    conf.check_cfg(package='gthread-2.0', atleast_version='2.6.0', uselib_store='gthread2', args='--cflags --libs')
    conf.check_cfg(package='sqlite3', atleast_version='3.5', uselib_store='sqlite3', args='--cflags --libs', mandatory=1)

    # Check for the sin function in the math lib
    conf.check_cc(lib='m', function_name='sin', header_name=['math.h'], uselib_store="math", mandatory=1)

    # Check if localtime_r exists
    if conf.check_cc(function_name='localtime_r', header_name=['time.h']):
        conf.env['localtime_impl'] = 'unix'
    else:
        conf.env['localtime_impl'] = 'dummy'

    # Detect the type of stat call used
    if Options.platform == 'win32':
        conf.env['statfs_impl'] = 'dummy'
    elif conf.check(header_name='sys/vfs.h'):
        if Options.platform == 'sunos':
            conf.env['statfs_impl'] = 'solaris'
        else:
            conf.env['statfs_impl'] = 'linux'
    elif conf.check(header_name='sys/param.h'):
        statfs_fragment = "#include <sys/param.h> \n#include <sys/mount.h> \nint main() { struct statfs foo; return 0; }\n"
        if not conf.check_cc(fragment=statfs_fragment, uselib_store="statfs", msg="Checking for struct statfs"):
            conf.env['statfs_impl'] = 'netbsd'
        else:
            conf.env['statfs_impl'] = 'bsd'
    else:
        conf.env['statfs_impl'] = 'dummy'

    # Add Darwin stuff
    if Options.platform == 'darwin':
        conf.env['LINKFLAGS'] += ['-framework', 'CoreFoundation']
        conf.env['CCDEFINES'] += ['USE_BUNDLES']

    if Options.platform == 'win32':
        conf.env['xmms_shared_library'] = True
    else:
        conf.env['xmms_shared_library'] = False

    if Options.platform == 'win32':
        conf.env['compat_impl'] = 'dummy'
    else:
        conf.env['compat_impl'] = 'unix'

    if not Options.options.without_unixshmserver:
        conf.check_cc(function_name='semctl', header_name=['sys/types.h','sys/ipc.h','sys/sem.h'])
        semun_fragment = "#include <time.h>\n#include <sys/sem.h>\n int main() { union semun foo; return 0; }\n"
        if not conf.check_cc(fragment=semun_fragment, uselib_store="semun", msg="Checking for union semun"):
            conf.env["CCDEFINES_shm"] += ["_SEM_SEMUN_UNDEFINED"]

    if not conf.env['HAVE_SEMCTL']:
        warning("Compiling visualization without shm support")

    conf.env.append_value('XMMS_PKGCONF_FILES', ('xmms2-plugin', ''))

    conf.check_cfg(package='valgrind', uselib_store='valgrind', args='--cflags')

    return True

def set_options(opt):
    opt.add_option('--disable-shmvis-server', action='store_true',
                   dest='without_unixshmserver', default=False,
                   help="Disable shared memory support for visualization")

=== src/clients/cli/wscript ===
import Options

def build(bld):
    obj = bld.new_task_gen('cc', 'program')
    obj.target = 'xmms2'
    obj.source = """
        cmd_config.c
        cmd_mlib.c
        cmd_other.c
        cmd_playback.c
        cmd_pls.c
        cmd_status.c
        cmd_coll.c
        common.c
        main.c
    """.split()

    obj.source.append('common_%s.c' % bld.env['common_impl'])

    if bld.env["xmms_icon"]:
        obj.add_objects = 'xmms_icon'

    obj.includes = '. ../../.. ../../include'
    obj.uselib_local = 'xmmsclient-glib xmmsclient'
    obj.uselib = 'glib2'

    obj = bld.new_task_gen(features='man', files='xmms2.1', section='1')

def configure(conf):
    if Options.platform == 'win32':
        conf.env['common_impl'] = 'win32'
    else:
        conf.env['common_impl'] = 'unix'

    return True

def set_options(opt):
    pass

=== src/clients/et/wscript ===
import Constants
import Options

def build(bld):
    obj = bld.new_task_gen('cc', 'program')
    obj.target = 'xmms2-et'
    obj.source = ['xmms2-et.c']
    obj.includes = '. ../../.. ../../include'
    obj.uselib = 'glib2 socket resolv'
    obj.uselib_local = 'xmmsclient-glib xmmsclient'

    obj = bld.new_task_gen('subst')
    obj.source = 'xmms2-et-launcher.sh.in'
    obj.dict = {'PRG_PATH' : bld.env['BINDIR']}
    obj.install_path = '${SCRIPTDIR}'
    obj.chmod = Constants.O755

    bld.new_task_gen(features='man', files='xmms2-et.1', section='1')

def configure(conf):
    if Options.platform == "win32":
        conf.fatal("Not supported on Windows")
    if Options.platform == "sunos":
        if not conf.check_cc(lib="resolv", uselib_store="resolv"):
            conf.fatal("libresolv needed on solaris")
    return True

def set_options(opt):
    pass

=== src/clients/launcher/wscript ===
import Options

def build(bld):
    obj = bld.new_task_gen('cc', 'program')
    obj.target = 'xmms2-launcher'
    obj.source = ['xmms2-launcher.c']
    obj.includes = '../../.. ../../include'
    obj.uselib = 'glib2'
    obj.uselib_local = 'xmmsutils'

    obj = bld.new_task_gen(features='man', files='xmms2-launcher.1', section='1')

def configure(conf):
    if Options.platform == 'win32':
        conf.fatal("Not supported on Windows")

def set_options(opt):
    pass

=== src/clients/medialib-updater/wscript ===
import Constants

def build(bld):
    obj = bld.new_task_gen('cc', 'program')
    obj.target = 'xmms2-mlib-updater'
    obj.source = "main.c"
    obj.includes = '. ../../.. ../../include'
    obj.uselib = 'glib2 GIO-2.0 GTHREAD-2.0'
    obj.uselib_local = 'xmmsclient-glib xmmsclient'

    obj = bld.new_task_gen('subst')
    obj.source = 'xmms2-mlib-updater.sh.in'
    obj.dict = {'PRG_PATH' : bld.env['BINDIR']}
    obj.install_path = "${SCRIPTDIR}"
    obj.chmod = Constants.O755

def configure(conf):
    conf.check_cfg(package="gio-2.0", args="--cflags --libs", mandatory=True)
    conf.check_cfg(package="gthread-2.0", args="--cflags --libs", mandatory=True)

    conf.check_cc(function_name="g_file_query_file_type", header_name="gio/gio.h", uselib="GIO-2.0")

def set_options(opt):
    pass

=== src/clients/nycli/wscript ===
def build(bld):
    obj = bld.new_task_gen('cc', 'program')
    obj.target = 'nyxmms2'
    obj.source = """main.c
                    cli_infos.c
                    cli_cache.c
                    command_trie.c
                    commands.c
                    command_utils.c
		    cmdnames.c
		    configuration.c
		    status.c		    
		    utils.c
		    alias.c
                    column_display.c
                    readline.c
                    playlist_positions.c""".split()
    obj.includes = '. ../../include'
    obj.uselib_local = 'xmmsclient'
    obj.uselib = 'glib2 readline readline-ncurses'

    obj = bld.new_task_gen(features='man', files='nyxmms2.1', section='1')

def configure(conf):
    rl_headers=["stdio.h", "readline/readline.h"]

    conf.check_cc(header_name=rl_headers, mandatory=True)

    # first try just linking against libreadline
    if conf.check_cc(lib="readline", header_name=rl_headers, function_name='rl_filename_dequoting_function', uselib_store="readline", uselib="glib2"):
        return

    # then try ncurses
    conf.check_cc(lib="ncurses", uselib_store="readline-ncurses", mandatory=True)

    if conf.check_cc(lib="readline", header_name=rl_headers, function_name='rl_filename_dequoting_function', uselib_store="readline", uselib="glib2 readline-ncurses"):
        return

    # Ok, we give up..
    conf.fatal("Cannot build nycli")

def set_options(opt):
    pass

=== src/clients/vistest/wscript ===
import Options

def build(bld):
    obj = bld.new_task_gen('cc', 'program')
    obj.target = 'vistest'
    obj.source = """vistest.c""".split()
    obj.includes = '. ../../.. ../../include'
    obj.uselib_local = 'xmmsclient-glib xmmsclient'
    obj.uselib = 'glib2'

    obj = bld.new_task_gen('cc', 'program')
    obj.target = 'vistest-fft'
    obj.source = """vistest_fft.c""".split()
    obj.includes = '. ../../.. ../../include'
    obj.uselib_local = 'xmmsclient-glib xmmsclient'
    obj.uselib = 'glib2 math'

    if bld.env['LIB_vorbisenc']:
        obj = bld.new_task_gen('cc', 'program')
        obj.target = 'xmms2-ripper'
        obj.source = 'ripper.c'
        obj.includes = '. ../../.. ../../include'
        obj.uselib_local = 'xmmsclient'
        obj.uselib = 'vorbisenc'

    if bld.env['LIB_visual'] and bld.env['LIB_sdl']:
        obj = bld.new_task_gen('cc', 'program')
        obj.target = 'xmms2-libvisual'
        obj.source = 'libvisual.c'
        obj.includes = '. ../../.. ../../include'
        obj.uselib_local = 'xmmsclient'
        obj.uselib = 'sdl visual'

def configure(conf):
    if Options.platform == "win32":
        conf.fatal("visualisation clients not supported on windows")

    conf.check_cc(lib="m", uselib_store="math")
    conf.check_cfg(package='libvisual-0.4', uselib_store='visual', args='--cflags --libs')
    conf.check_cfg(package='sdl', uselib_store='sdl', args='--cflags --libs')
    conf.check_cfg(package='vorbisenc', uselib_store='vorbisenc', args='--cflags --libs')

def set_options(opt):
    pass

=== debian/changelog ===
xmms2 (0.7DrNo+dfsg-2ubuntu1) oneiric; urgency=low

  * Backport from upstream:
    - Fix avcodec plugin to work with latest libavcodec (LP: #832769).

 -- Colin Watson <cjwatson@ubuntu.com>  Thu, 01 Sep 2011 11:36:28 +0100

xmms2 (0.7DrNo+dfsg-2build2) oneiric; urgency=low

  * Rebuild for Perl 5.12.

 -- Colin Watson <cjwatson@ubuntu.com>  Mon, 09 May 2011 09:47:05 +0100

xmms2 (0.7DrNo+dfsg-2build1) natty; urgency=low

  * Rebuild to add support for python 2.7.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 03 Dec 2010 00:17:16 +0000

xmms2 (0.7DrNo+dfsg-2) unstable; urgency=low

  * Add bp-glib-version-check.patch to make glib check sane. (Closes: #522280)

 -- Benjamin Drung <bdrung@ubuntu.com>  Mon, 02 Aug 2010 23:43:55 +0200

xmms2 (0.7DrNo+dfsg-1) unstable; urgency=low

  * Repack source to replace non-free mind.in.a.box snippet by DSFG-compliant
    one that was chosen by upstream; update debian/copyright. (Closes: #583309)
  * debian/watch: Mangle version to strip dfsg.
  * Bump Standards-Version to 3.9.1 (no changes required).
  * Refer to versioned common license file.
  * Use Breaks instead of Conflicts.
  * Do not build xmms2 in parallel by default. (Closes: #586835)
  * Backport patch to extend command-line length of nycli. (Closes: #580862)
    Thanks to Andrew McMillan
  * Explicitly choose the python version to run waf. (Closes: #583757)
    Thanks to Rémi Vanicat for the patch.
  * Change description of xmms2-plugin-smb from "Samba" to "Server Message
    Block (SMB)". (Closes: #574997)
  * Backport workaround for libavcodec initialization bug. (Closes: #588519)
  * Fix tta plugin to work with segment with startms. (Closes: #588519)
    Thanks to Yang Zhe <yangzhe1990@gmail.com> for the patch.

 -- Benjamin Drung <bdrung@ubuntu.com>  Sat, 31 Jul 2010 22:19:38 +0200

xmms2 (0.7DrNo-7) unstable; urgency=low

  * Use PulseAudio as default output plugin on Ubuntu and derived distributions.

 -- Benjamin Drung <bdrung@ubuntu.com>  Sat, 08 May 2010 15:44:19 +0200

xmms2 (0.7DrNo-6) unstable; urgency=high

  * Change architecture of xmms2 and xmms2-plugin-all from all to any to
    fix FTBFS (Closes: #580287).

 -- Benjamin Drung <bdrung@ubuntu.com>  Fri, 07 May 2010 10:48:30 +0200

xmms2 (0.7DrNo-5) unstable; urgency=low

  * Disable ALSA on hurd-i386 and use OSS instead.

 -- Benjamin Drung <bdrung@ubuntu.com>  Sun, 04 Apr 2010 18:53:06 +0200

=== debian/control ===
Source: xmms2
Section: sound
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Florian Ragwitz <rafl@debian.org>
Uploaders: Jens Taprogge <jlt@taprogge.org>,
           Jonne Lehtinen <jms@modeemi.fi>,
           Anders Waldenborg <anders@0x63.nu>,
           Benjamin Drung <bdrung@ubuntu.com>
Standards-Version: 3.9.1
Build-Depends: debhelper (>= 7.0.50~),
               libao-dev,
               libasound2-dev [!kfreebsd-i386 !kfreebsd-amd64 !hurd-i386],
               libavahi-client-dev,
               libavahi-glib-dev,
               libavcodec-dev,
               libboost-dev,
               libboost-signals-dev,
               libcdio-cdda-dev,
               libcurl4-openssl-dev,
               libdiscid0-dev,
               libexpat1-dev,
               libfaad-dev,
               libfftw3-dev,
               libflac-dev,
               libgamin-dev,
               libglib2.0-dev,
               libgme-dev,
               libjack-dev,
               libmad0-dev,
               libmms-dev,
               libmodplug-dev,
               libmpcdec-dev,
               libmpg123-dev (>= 1.5.1),
               libofa0-dev,
               libperl-dev,
               libpulse-dev,
               libreadline-dev,
               libresid-builder-dev,
               libsamplerate-dev,
               libsdl1.2-dev,
               libshout-dev,
               libsidplay2-dev,
               libsmbclient-dev,
               libsqlite3-dev,
               libvisual-0.4-dev,
               libvorbis-dev,
               libwavpack-dev,
               libxml2-dev,
               python-all-dev (>= 2.3.5-11),
               python-pyrex,
               python-support (>= 0.90),
               ruby,
               ruby1.8-dev
DM-Upload-Allowed: yes
Vcs-Git: git://git.debian.org/git/pkg-xmms2/xmms2
Vcs-Browser: http://git.debian.org/?p=pkg-xmms2/xmms2.git
Homepage: http://xmms2.xmms.se/

Package: xmms2
Architecture: any
Depends: xmms2-client-cli,
         xmms2-core,
         xmms2-icon,
         xmms2-plugin-alsa [!kfreebsd-i386 !kfreebsd-amd64 !hurd-i386],
         xmms2-plugin-id3v2,
         xmms2-plugin-mad,
         xmms2-plugin-oss [kfreebsd-i386 kfreebsd-amd64 hurd-i386],
         xmms2-plugin-vorbis,
         ${misc:Depends}
Recommends: xmms2-client-nycli
Conflicts: xmms2-plugin-nulstripper
Replaces: xmms2-plugin-nulstripper
Description: Client/server based media player system
 XMMS2 is a redesign of the XMMS music player. It features a client-server
 model, allowing multiple (even simultaneous!) user interfaces, both textual
 and graphical. All common audio formats are supported using plug-ins. On top of
 this, there is a flexible media library to organize your music.
 .
 This package is a metapackage depending on various other XMMS2 packages.
 Installing this package gets you a command line client and enables XMMS2
 playback of Ogg Vorbis and MP3 files from local and remote sources.

Package: xmms2-plugin-all
Architecture: any
Depends: xmms2-plugin-airplay,
         xmms2-plugin-alsa [!kfreebsd-i386 !kfreebsd-amd64 !hurd-i386],
         xmms2-plugin-ao,
         xmms2-plugin-apefile,
         xmms2-plugin-asf,
         xmms2-plugin-asx,
         xmms2-plugin-avcodec,
         xmms2-plugin-cdda,
         xmms2-plugin-cue,
         xmms2-plugin-curl,
         xmms2-plugin-daap,
         xmms2-plugin-faad,
         xmms2-plugin-flac,
         xmms2-plugin-flv,
         xmms2-plugin-gme,
         xmms2-plugin-gvfs,
         xmms2-plugin-html,
         xmms2-plugin-ices,
         xmms2-plugin-icymetaint,
         xmms2-plugin-id3v2,
         xmms2-plugin-jack,
         xmms2-plugin-karaoke,
         xmms2-plugin-m3u,
         xmms2-plugin-mad,
         xmms2-plugin-mms,
         xmms2-plugin-modplug,
         xmms2-plugin-mp4,
         xmms2-plugin-mpg123,
         xmms2-plugin-musepack,
         xmms2-plugin-normalize,
         xmms2-plugin-ofa,
         xmms2-plugin-oss,
         xmms2-plugin-pls,
         xmms2-plugin-pulse,
         xmms2-plugin-rss,
         xmms2-plugin-sid,
         xmms2-plugin-smb,
         xmms2-plugin-speex,
         xmms2-plugin-tta,
         xmms2-plugin-vocoder,
         xmms2-plugin-vorbis,
         xmms2-plugin-wavpack,
         xmms2-plugin-xml,
         xmms2-plugin-xspf,
         ${misc:Depends}
Description: XMMS2 - all plug-ins
 XMMS2 is a redesign of the XMMS music player. It features a client-server
 model, allowing multiple (even simultaneous!) user interfaces, both textual
 and graphical. All common audio formats are supported using plug-ins. On top of
 this, there is a flexible media library to organize your music.
 .
 This is a metapackage depending on all available XMMS2 plug-ins to make
 installation easier.

Package: xmms2-dev
Architecture: all
Section: libdevel
Depends: pkg-config,
         ${misc:Depends}
Description: XMMS2 - plug-in development files
 XMMS2 is a redesign of the XMMS music player. It features a client-server
 model, allowing multiple (even simultaneous!) user interfaces, both textual
 and graphical. All common audio formats are supported using plug-ins. On top of
 this, there is a flexible media library to organize your music.
 .
 This package contains headers required for developing XMMS2 plug-ins.

Package: xmms2-core
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Conflicts: libxmmsclient++1,
           libxmmsclient++2,
           libxmmsclient2,
           libxmmsclient3,
           libxmmsclient4
Description: XMMS2 - core package
 XMMS2 is a redesign of the XMMS music player. It features a client-server
 model, allowing multiple (even simultaneous!) user interfaces, both textual
 and graphical. All common audio formats are supported using plug-ins. On top of
 this, there is a flexible media library to organize your music.
 .
 This package just contains the daemon that loads plug-ins and allows clients to
 connect.

Package: xmms2-et
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: XMMS2 - phone home package
 XMMS2 is a redesign of the XMMS music player. It features a client-server
 model, allowing multiple (even simultaneous!) user interfaces, both textual
 and graphical. All common audio formats are supported using plug-ins. On top of
 this, there is a flexible media library to organize your music.
 .
 This package contains a small program that (anonymously) reports back
 information on your computer and XMMS2 configuration to the XMMS2 developers.

Package: xmms2-icon
Architecture: all
Depends: ${misc:Depends}
Breaks: xmms2-core (<= 0.6DrMattDestruction-1)
Replaces: xmms2-core (<= 0.6DrMattDestruction-1)
Description: XMMS2 - icon package
 XMMS2 is a redesign of the XMMS music player. It features a client-server
 model, allowing multiple (even simultaneous!) user interfaces, both textual
 and graphical. All common audio formats are supported using plug-ins. On top of
 this, there is a flexible media library to organize your music.
 .
 This package just contains the icon files.

Package: libxmmsclient6
Architecture: any
Section: libs
Conflicts: libxmmsclient2,
           libxmmsclient3,
           libxmmsclient4,
           libxmmsclient5
Replaces: libxmmsclient2,
          libxmmsclient3,
          libxmmsclient4,
          libxmmsclient5
Depends: ${misc:Depends},
         ${shlibs:Depends}
Breaks: xmms2-core (<< 0.6DrMattDestruction)
Description: XMMS2 - client library
 XMMS2 is a redesign of the XMMS music player. It features a client-server
 model, allowing multiple (even simultaneous!) user interfaces, both textual
 and graphical. All common audio formats are supported using plug-ins. On top of
 this, there is a flexible media library to organize your music.
 .
 This package contains a client library written in c.

Package: libxmmsclient-dev
Architecture: any
Section: libdevel
Depends: libxmmsclient6 (= ${binary:Version}),
         pkg-config,
         xmms2-dev,
         ${misc:Depends}
Description: XMMS2 - client library development files
 XMMS2 is a redesign of the XMMS music player. It features a client-server
 model, allowing multiple (even simultaneous!) user interfaces, both textual
 and graphical. All common audio formats are supported using plug-ins. On top of
 this, there is a flexible media library to organize your music.
 .
 This package contains files for developing XMMS2 clients using libxmmsclient6.

Package: libxmmsclient-glib1
Architecture: any
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: XMMS2 - glib client library
 XMMS2 is a redesign of the XMMS music player. It features a client-server
 model, allowing multiple (even simultaneous!) user interfaces, both textual
 and graphical. All common audio formats are supported using plug-ins. On top of
 this, there is a flexible media library to organize your music.
 .
 This package contains a glib based client library written in c.

Package: libxmmsclient-glib-dev
Architecture: any
Section: libdevel
Depends: libglib2.0-dev,
         libxmmsclient-dev,
         libxmmsclient-glib1 (= ${binary:Version}),
         pkg-config,
         ${misc:Depends}
Description: XMMS2 - glib client library - development files
 XMMS2 is a redesign of the XMMS music player. It features a client-server
 model, allowing multiple (even simultaneous!) user interfaces, both textual
 and graphical. All common audio formats are supported using plug-ins. On top of
 this, there is a flexible media library to organize your music.
 .
 This package contains files for developing XMMS2 clients using
 libxmmsclient-glib1.

Package: libxmmsclient++4
Architecture: any
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Conflicts: libxmmsclient++1,
           libxmmsclient++2,
           libxmmsclient++3
Replaces: libxmmsclient++1,
          libxmmsclient++2,
          libxmmsclient++3
Breaks: xmms2-core (<< 0.6DrMattDestruction)
Description: XMMS2 - client library for c++
 XMMS2 is a redesign of the XMMS music player. It features a client-server
 model, allowing multiple (even simultaneous!) user interfaces, both textual
 and graphical. All common audio formats are supported using plug-ins. On top of
 this, there is a flexible media library to organize your music.
 .
 This package contains a client library written in c++.

Package: libxmmsclient++-dev
Architecture: any
Section: libdevel
Depends: libboost-dev,
         libxmmsclient++4 (= ${binary:Version}),
         libxmmsclient-dev,
         pkg-config,
         ${misc:Depends}
Description: XMMS2 - client library for c++ - development files
 XMMS2 is a redesign of the XMMS music player. It features a client-server
 model, allowing multiple (even simultaneous!) user interfaces, both textual
 and graphical. All common audio formats are supported using plug-ins. On top of
 this, there is a flexible media library to organize your music.
 .
 This package contains files for developing XMMS2 clients using
 libxmmsclient++4.

Package: libxmmsclient++-glib1
Architecture: any
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: XMMS2 - glib client library for c++
 XMMS2 is a redesign of the XMMS music player. It features a client-server
 model, allowing multiple (even simultaneous!) user interfaces, both textual
 and graphical. All common audio formats are supported using plug-ins. On top of
 this, there is a flexible media library to organize your music.
 .
 This package contains a glib based client library written in c++.

Package: libxmmsclient++-glib-dev
Architecture: any
Section: libdevel
Depends: libxmmsclient++-dev,
         libxmmsclient++-glib1 (= ${binary:Version}),
         libxmmsclient-glib-dev,
         pkg-config,
         ${misc:Depends}
Description: XMMS2 - glib client library for c++ - development files
 XMMS2 is a redesign of the XMMS music player. It features a client-server

=== debian/watch ===
version=3
opts=dversionmangle=s/\+dfsg\d*$// http://sf.net/xmms2/xmms2-(.*)\.tar\.bz2
